#Include Once "GL/glu.bi"

Type font
        listbase As UInteger
        texture As UInteger
        mode As Ubyte
        scale As Single
        Declare Destructor()
        Declare Constructor()
        Declare Sub Print(Byval X As Integer, Byval Y As Integer, byref Text As String)
        Declare Sub Printc(Byval X As Integer, Byval Y As Integer, byref Text As String)
        Declare Sub setFixed(h As Integer)
        Declare Sub setFree()
End Type

Destructor font()
        glDeleteLists this.listbase, 256
        glDeleteTextures 1, @this.texture
End Destructor

Sub font.print(Byval X As Integer, Byval Y As Integer, byref Text As String)
        Dim As Integer w, h
       
        glEnable GL_TEXTURE_2D
        glBindTexture GL_TEXTURE_2D, this.texture
        glMatrixMode GL_PROJECTION
        glPushMatrix
        glLoadIdentity
        ScreenInfo w,h
        glOrtho 0,w,h,0,-1,1
        glMatrixMode GL_MODELVIEW
        glPushMatrix
        glEnable GL_ALPHA
        glEnable GL_BLEND
        glBlendFunc GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA
        glLoadIdentity
        If mode Then
                glTranslatef x*(8*scale),y*(8*scale),0
        Else
                glTranslatef x,y,0
        Endif
        If scale<>1 Then glScalef scale,scale,1
        glListBase this.listbase
                For i As Integer = 1 To Len(Text)
                        glCallList this.listbase+Text[i-1]
                Next
        glScalef 1,1,1
        glBindTexture GL_TEXTURE_2D, 0
        glMatrixMode GL_Projection
        glPopMatrix
        glMatrixMode GL_ModelView
        glPopMatrix
End Sub

Sub font.printc(Byval X As Integer, Byval Y As Integer, byref Text As String)
        Dim As Integer w, h
       
        glEnable GL_TEXTURE_2D
        glBindTexture GL_TEXTURE_2D, this.texture
        glMatrixMode GL_PROJECTION
        glPushMatrix
        glLoadIdentity
        ScreenInfo w,h
        glOrtho 0,w,h,0,-1,1
        glMatrixMode GL_MODELVIEW
        glPushMatrix
        glEnable GL_ALPHA
        glEnable GL_BLEND
        glBlendFunc GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA
        glLoadIdentity
        If mode Then
                glTranslatef x*(8*scale),y*(8*scale),0
        Else
                glTranslatef x-Len(text)*(4*scale),y,0
        Endif
        If scale<>1 Then glScalef scale,scale,1
        glListBase this.listbase
                For i As Integer = 1 To Len(Text)
                        glCallList this.listbase+Text[i-1]
                Next
        glScalef 1,1,1
        glBindTexture GL_TEXTURE_2D, 0
        glMatrixMode GL_Projection
        glPopMatrix
        glMatrixMode GL_ModelView
        glPopMatrix
End Sub

Constructor font()

        Dim As Integer        gloop
        Dim As Any Ptr        img
        Dim As Double        pixels, x,y,w,h
        With this
       
                img = ImageCreate(128,128)
                Line img, (0,0)-(127,127), RGBA(0,0,0,0), bf
               
                For x As Integer = 0 To 15
                        For y As Integer = 0 To 15
                                Draw String img, (x*8,y*8), Chr(x+y*16)
                        Next
                Next

                glGenTextures (1, @.texture)
                glBindTexture (GL_TEXTURE_2D, .texture)

                glTexImage2D GL_TEXTURE_2D, 0, GL_RGBA, 128, 128, 0, GL_BGRA, GL_UNSIGNED_BYTE, img+32
                glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST
                glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST

                imageDestroy img
       
                .listbase = glGenLists(256)
                pixels = 1/128
                For gloop = 0 To 255

                        y = Fix(gloop /16)*8 * pixels
                        x = (gloop Mod 16)*8 * pixels
                        w = 8 * pixels
                        h = 8 * pixels
                        glNewList .listbase+gloop, GL_COMPILE
                        glBegin GL_QUADS
                                glTexCoord2f x,y+h
                                glVertex2i 0, 8
                               
                                glTexCoord2f x+w,y+h
                                glVertex2i 8, 8
                               
                                glTexCoord2f x+w,y
                                glVertex2i 8, 0
                               
                                glTexCoord2f x,y
                                glVertex2i 0, 0
                        glEnd
                        glTranslatef 8,0,0
                        glEndList
                Next
               
                scale = 1
        End With

End Constructor

Sub font.setFixed(h As Integer)
        Dim As Integer        ww,wh
        ScreenInfo ww,wh
        mode = 1
        scale = wh/h/8
End Sub

Sub font.setFree()
        mode = 0
End Sub
